## receptor 1.4.4

=== Makefile ===
# If the current commit has been tagged, use that as the version.
# Otherwise include short commit hash.
OFFICIAL_VERSION := $(shell if VER=`git describe --exact-match --tags 2>/dev/null`; then echo $$VER; else echo ""; fi)
ifeq ($(OFFICIAL_VERSION),)
VERSION := $(shell git describe --tags | cut -d - -f -1)+g$(shell git rev-parse --short HEAD)
else
VERSION := $(OFFICIAL_VERSION)
endif


# When building Receptor, tags can be used to remove undesired
# features.  This is primarily used for deploying Receptor in a
# security sensitive role, where it is desired to have no possibility
# of a service being accidentally enabled.  Features are controlled
# using the TAGS environment variable, which is a comma delimeted
# list of zero or more of the following:
#
# no_controlsvc:  Disable the control service
#
# no_backends:    Disable all backends (except external via the API)
# no_tcp_backend: Disable the TCP backend
# no_udp_backend: Disable the UDP backend
# no_websocket_backend: Disable the websocket backent
#
# no_services:    Disable all services
# no_proxies:     Disable the TCP, UDP and Unix proxy services
# no_ip_router:   Disable the IP router service
#
# no_tls_config:  Disable the ability to configure TLS server/client configs
#
# no_workceptor:  Disable the unit-of-work subsystem (be network only)
#
# no_cert_auth:   Disable commands related to CA and certificate generation

TAGS ?=
ifeq ($(TAGS),)
	TAGPARAM=
else
	TAGPARAM=--tags $(TAGS)
endif

DEBUG ?=
ifeq ($(DEBUG),1)
	DEBUGFLAGS=-gcflags=all="-N -l"
else
	DEBUGFLAGS=
endif

receptor: $(shell find pkg -type f -name '*.go') ./cmd/receptor-cl/receptor.go
	CGO_ENABLED=0 GOFLAGS="-buildvcs=false" go build -o receptor $(DEBUGFLAGS) -ldflags "-X 'github.com/ansible/receptor/internal/version.Version=$(VERSION)'" $(TAGPARAM) ./cmd/receptor-cl

clean:
	@rm -fv .container-flag*
	@rm -fv .VERSION
	@rm -rfv dist/
	@rm -fv $(KUBECTL_BINARY)
	@rm -fv packaging/container/receptor
	@rm -rfv packaging/container/RPMS/
	@rm -fv packaging/container/*.whl
	@rm -fv receptor receptor.exe receptor.app net
	@rm -fv receptorctl/dist/*
	@rm -fv receptor-python-worker/dist/*
	@rm -rfv receptorctl-test-venv/

ARCH=amd64
OS=linux

KUBECTL_BINARY=./kubectl
STABLE_KUBECTL_VERSION=$(shell curl --silent https://storage.googleapis.com/kubernetes-release/release/stable.txt)
kubectl:
	if [ "$(wildcard $(KUBECTL_BINARY))" != "" ]; \
	then \
		FOUND_KUBECTL_VERSION=$$(./kubectl version --client=true | head --lines=1 | cut --delimiter=' ' --field=3); \
	else \
		FOUND_KUBECTL_VERSION=; \
	fi
	if [ "${FOUND_KUBECTL_VERSION}" != "$(STABLE_KUBECTL_VERSION)" ]; \
	then \
		curl \
			--location \
			--output $(KUBECTL_BINARY) \
			https://storage.googleapis.com/kubernetes-release/release/$(STABLE_KUBECTL_VERSION)/bin/$(OS)/$(ARCH)/kubectl; \
		chmod 0700 $(KUBECTL_BINARY); \
	fi

lint:
	@golint cmd/... pkg/... example/...

receptorctl-lint: receptorctl/.VERSION
	@cd receptorctl && tox -e lint

format:
	@find cmd/ pkg/ -type f -name '*.go' -exec go fmt {} \;

fmt: format

pre-commit:
	@pre-commit run --all-files

build-all:
	@echo "Running Go builds..." && \
	GOOS=windows go build -o receptor.exe ./cmd/receptor-cl && \
	GOOS=darwin go build -o receptor.app ./cmd/receptor-cl && \
	go build example/*.go && \
	go build -o receptor --tags no_backends,no_services,no_tls_config ./cmd/receptor-cl && \
	go build -o receptor ./cmd/receptor-cl

DIST := receptor_$(shell echo '$(VERSION)' | sed 's/^v//')_$(GOOS)_$(GOARCH)
build-package:
	@echo "Building and packaging binary for $(GOOS)/$(GOARCH) as dist/$(DIST).tar.gz" && \
	mkdir -p dist/$(DIST) && \
	GOOS=$(GOOS) GOARCH=$(GOARCH) CGO_ENABLED=0 go build -o dist/$(DIST)/$(BINNAME) $(DEBUGFLAGS) -ldflags "-X 'github.com/ansible/receptor/internal/version.Version=$(VERSION)'" $(TAGPARAM) ./cmd/receptor-cl && \
	tar -C dist/$(DIST) -zcf dist/$(DIST).tar.gz $(BINNAME) && \
	cd dist/ && sha256sum $(DIST).tar.gz >> checksums.txt

RUNTEST ?=
ifeq ($(RUNTEST),)
TESTCMD =
else
TESTCMD = -run $(RUNTEST)
endif

BLOCKLIST='/tests/|mock_|example'
COVERAGE_FILE='coverage.txt'

coverage: build-all
	PATH="${PWD}:${PATH}" go test $$(go list ./... | grep -vE $(BLOCKLIST)) \
	  $(TESTCMD) \
	  -count=1 \
	  -cover \
	  -covermode=atomic \
	  -coverprofile=$(COVERAGE_FILE) \
	  -race \
	  -timeout 5m

test: receptor
	PATH="${PWD}:${PATH}" \
	go test ./... $(TESTCMD) -count=1 -race -timeout 5m

receptorctl-test: receptorctl/.VERSION
	@cd receptorctl && tox -e py3

testloop: receptor
	@i=1; while echo "------ $$i" && \
	  make test; do \
	  i=$$((i+1)); done

kubetest: kubectl
	./kubectl get nodes

version:
	@echo $(VERSION) > .VERSION
	@echo ".VERSION created for $(VERSION)"

receptorctl/.VERSION:
	echo $(VERSION) > $@

RECEPTORCTL_WHEEL = receptorctl/dist/receptorctl-$(VERSION:v%=%)-py3-none-any.whl
$(RECEPTORCTL_WHEEL): receptorctl/README.md receptorctl/.VERSION $(shell find receptorctl/receptorctl -type f -name '*.py')
	@cd receptorctl && python3 -m build --wheel

receptorctl_wheel: $(RECEPTORCTL_WHEEL)

RECEPTORCTL_SDIST = receptorctl/dist/receptorctl-$(VERSION:v%=%).tar.gz
$(RECEPTORCTL_SDIST): receptorctl/README.md receptorctl/.VERSION $(shell find receptorctl/receptorctl -type f -name '*.py')
	@cd receptorctl && python3 -m build --sdist

receptorctl_sdist: $(RECEPTORCTL_SDIST)

receptor-python-worker/.VERSION:
	echo $(VERSION) > $@

RECEPTOR_PYTHON_WORKER_WHEEL = receptor-python-worker/dist/receptor_python_worker-$(VERSION:v%=%)-py3-none-any.whl
$(RECEPTOR_PYTHON_WORKER_WHEEL): receptor-python-worker/README.md receptor-python-worker/.VERSION $(shell find receptor-python-worker/receptor_python_worker -type f -name '*.py')
	@cd receptor-python-worker && python3 -m build --wheel

# Container command can be docker or podman
CONTAINERCMD ?= podman

# Repo without tag
REPO := quay.io/ansible/receptor
# TAG is VERSION with a '-' instead of a '+', to avoid invalid image reference error.
TAG := $(subst +,-,$(VERSION))
# Set this to tag image as :latest in addition to :$(VERSION)
LATEST :=

EXTRA_OPTS ?=

space := $(subst ,, )
CONTAINER_FLAG_FILE = .container-flag-$(VERSION)$(subst $(space),,$(subst /,,$(EXTRA_OPTS)))
container: $(CONTAINER_FLAG_FILE)
$(CONTAINER_FLAG_FILE): $(RECEPTORCTL_WHEEL) $(RECEPTOR_PYTHON_WORKER_WHEEL)
	@tar --exclude-vcs-ignores -czf packaging/container/source.tar.gz .
	@cp $(RECEPTORCTL_WHEEL) packaging/container
	@cp $(RECEPTOR_PYTHON_WORKER_WHEEL) packaging/container
	$(CONTAINERCMD) build $(EXTRA_OPTS) packaging/container --build-arg VERSION=$(VERSION:v%=%) -t $(REPO):$(TAG) $(if $(LATEST),-t $(REPO):latest,)
	touch $@

tc-image: container
	@cp receptor packaging/tc-image/
	@$(CONTAINERCMD) build packaging/tc-image -t receptor-tc

.PHONY: lint format fmt pre-commit build-all test clean testloop container version receptorctl-tests kubetest

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS    ?=
SPHINXBUILD   ?= sphinx-build
SOURCEDIR     = source
BUILDDIR      = build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)


server:
	python3 -m http.server

=== docs/requirements.txt ===
pbr
sphinx
six

=== tests/Makefile ===
CONTAINER_IMAGE_TAG_builder=ansible/receptor:builder
CONTAINER_IMAGE_TAG_dev=ansible/receptor:dev

CONTAINER_RUN:=$$(./receptor-tester.sh container-runtime)

# Tests
GO_FUNCTIONAL_TESTS_DIRS:=$$(find ./functional -type d)

# Generate artifacts
artifacts: container-image-builder
	mkdir -p $(PWD)/artifacts-output
	$(CONTAINER_RUN) run --rm \
		-v $(PWD)/../:/source/ \
		-v $(PWD)/artifacts-output/:/artifacts/:rw \
		-v receptor_go_root_cache:/root/go:rw \
		-e OUTPUT_UID=$$(id -u) \
		$(CONTAINER_IMAGE_TAG_builder) \
		/build-artifacts.sh

artifacts-no-cache: container-image-builder
	mkdir -p $(PWD)/artifacts
	$(CONTAINER_RUN) run --rm \
		-v $(PWD)/../:/source/:ro \
		-v $(PWD)/artifacts/:/artifacts/:rw \
		$(CONTAINER_IMAGE_TAG_builder) \
		/build-artifacts.sh

# Container environment
container-image-dev:
	$(CONTAINER_RUN) build \
		-t $(CONTAINER_IMAGE_TAG_dev) \
		-f ./environments/container-dev/Containerfile \
		./../

container-image-builder:
	$(CONTAINER_RUN) build \
		-t $(CONTAINER_IMAGE_TAG_builder) \
		-f ./environments/container-builder/Containerfile \
		./../

container-image-dev-shell:
	$(CONTAINER_RUN) run -it --rm \
		$(CONTAINER_IMAGE_TAG_dev) bash

container-image-builder-shell:
	$(CONTAINER_RUN) run -it --rm \
		-v $(PWD)/../:/source/:ro \
		-v receptor_go_root_cache:/root/go:rw \
		$(CONTAINER_IMAGE_TAG_builder) bash -c \
			'cp -r /source /build; cd /build; bash'

# VM (vagrant)
vm: vm-create

vm-create:
	cd environments/vagrant && \
	vagrant up

shell: vm-shell
vm-shell:
	@cd environments/vagrant && \
	vagrant ssh -c "cd /vagrant/tests && /bin/bash"

vm-destroy:
	cd environments/vagrant && \
	vagrant destroy

vm-provision:
	cd environments/vagrant && \
	vagrant provision

# Colored output
ccblue=$(echo -e "\033[0;31m")
ccred=$(echo -e "\033[0;31m")
ccyellow=$(echo -e "\033[0;33m")
ccend=$(echo -e "\033[0m")

# Other configs
SHELL:=/bin/bash

=== debian/changelog ===
receptor (1.4.4-1) unstable; urgency=medium

  * New upstream version 1.4.4
  * Patch to use old golang mock
  * Drop applied patches

 -- Jérémy Lal <kapouer@melix.org>  Wed, 07 Feb 2024 18:27:57 +0100

receptor (1.4.3-5) unstable; urgency=medium

  * Inject version at build
  * Patch to wait more time for a test

 -- Jérémy Lal <kapouer@melix.org>  Wed, 17 Jan 2024 11:05:10 +0100

receptor (1.4.3-4) unstable; urgency=medium

  * Simplify and fix rules so all/any targets work
  * patch: disable TestCreatePing, closes: 1060223.

 -- Jérémy Lal <kapouer@melix.org>  Mon, 08 Jan 2024 00:13:58 +0100

receptor (1.4.3-3) unstable; urgency=medium

  * Source-only upload 

 -- Jérémy Lal <kapouer@melix.org>  Sun, 07 Jan 2024 02:41:58 +0100

receptor (1.4.3-2) unstable; urgency=medium

  * copyright: missing file and debian dir
  * patch:
    + add missing headers
	  + upstream go 1.20/1.21 compatibility
  * enable receptorctl python tests
  * dev package: add example

 -- Jérémy Lal <kapouer@melix.org>  Sat, 06 Jan 2024 13:25:21 +0100

receptor (1.4.3-1) unstable; urgency=medium

  * Initial release (Closes: #1027779)

 -- Jérémy Lal <kapouer@melix.org>  Fri, 05 Jan 2024 00:16:03 +0100

=== debian/control ===
Source: receptor
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Jérémy Lal <kapouer@melix.org>
Section: golang
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
 dh-sequence-golang,
 dh-sequence-python3,
 dh-sequence-sphinxdoc,
 sphinx,
 pybuild-plugin-pyproject,
 python3-setuptools,
 python3-all,
 python3-pytest,
 python3-urllib3,
 python3-click,
 python3-dateutil,
 python3-yaml,
 tox,
 ca-certificates,
 help2man,
 lsof,
 psmisc,
 openssh-client,
 golang-any,
 golang-github-creack-pty-dev,
 golang-github-fortytw2-leaktest-dev,
 golang-github-fsnotify-fsnotify-dev,
 golang-github-ghjm-cmdline-dev,
 golang-github-golang-jwt-jwt-dev,
 golang-github-golang-mock-dev,
 golang-github-google-shlex-dev,
 golang-github-gorilla-websocket-dev,
 golang-github-minio-highwayhash-dev,
 golang-github-pbnjay-memory-dev,
 golang-github-quic-go-quic-go-dev,
 golang-github-rogpeppe-go-internal-dev,
 golang-github-songgao-water-dev,
 golang-github-vishvananda-netlink-dev,
 golang-golang-x-net-dev,
 golang-gopkg-yaml.v2-dev,
 golang-k8s-api-dev,
 golang-k8s-apimachinery-dev,
 golang-k8s-client-go-dev,
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/go-team/packages/receptor
Vcs-Git: https://salsa.debian.org/go-team/packages/receptor.git
Homepage: https://github.com/ansible/receptor
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/ansible/receptor

Package: golang-github-ansible-receptor-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
 golang-github-creack-pty-dev,
 golang-github-fortytw2-leaktest-dev,
 golang-github-fsnotify-fsnotify-dev,
 golang-github-ghjm-cmdline-dev,
 golang-github-golang-jwt-jwt-dev,
 golang-github-golang-mock-dev,
 golang-github-google-shlex-dev,
 golang-github-gorilla-websocket-dev,
 golang-github-minio-highwayhash-dev,
 golang-github-pbnjay-memory-dev,
 golang-github-quic-go-quic-go-dev,
 golang-github-rogpeppe-go-internal-dev,
 golang-github-songgao-water-dev,
 golang-github-vishvananda-netlink-dev,
 golang-golang-x-net-dev,
 golang-gopkg-yaml.v2-dev,
 golang-k8s-api-dev,
 golang-k8s-apimachinery-dev,
 golang-k8s-client-go-dev,
Description: Daemon for controlling a mesh of nodes and workers (library)
 Receptor is an overlay network intended to ease the distribution
 of work across a large and dispersed collection of workers.
 Receptor nodes establish peer-to-peer connections with each other via
 existing networks.
 .
 These are the Golang development files.

Package: receptor
Section: web
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends},
	python3-receptorctl,
	python3-receptor-python-worker,
Built-Using: ${misc:Built-Using}
Suggests: receptor-doc
Description: Daemon for controlling a mesh of nodes and workers
 Receptor is an overlay network intended to ease the distribution
 of work across a large and dispersed collection of workers.
 Receptor nodes establish peer-to-peer connections with each other via
 existing networks.

Package: receptor-doc
Architecture: all
Section: doc
Built-Using: ${sphinxdoc:Built-Using}
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Description: Receptor HTML documentation
 Users, developers, and contributors guides.
 .
 Receptor is a daemon for controlling a mesh of nodes and workers.


Package: python3-receptorctl
Section: python
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}
Description: Python library and client for interacting with receptor daemon
 This provides the Python library and command-line client to interact
 with receptor over its control socket interface.
 .
 Receptor is a daemon for controlling a mesh of nodes and workers.


Package: python3-receptor-python-worker
Section: python
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}
Description: Command to let receptor supervise a Python worker plugin
 Receptor calls this command to supervise worker operations inside
 a node.
 .
 Receptor is a daemon for controlling a mesh of nodes and workers.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk
include /usr/share/dpkg/pkg-info.mk

# needed by tests
export DH_GOLANG_INSTALL_EXTRA := pkg/controlsvc/reload_test_yml

# do not package example
export DH_GOLANG_EXCLUDES := example

# do not test kubernetes yet
export SKIP_KUBE = 1

# needed for receptor tests
export PATH := $(CURDIR)/_build/bin/:$(PATH)

export PYBUILD_SYSTEM = pyproject

%:
	dh $@ --builddirectory=_build --buildsystem=golang

debian/receptor.1:
	help2man --output=$@ --name="Main controller daemon" --version-string="$(DEB_VERSION_UPSTREAM)" _build/bin/receptor

debian/receptorctl.1:
	cd receptorctl && help2man --output=../$@ --name="Receptor daemon client" --version-string="$(DEB_VERSION_UPSTREAM)" python3 -m receptorctl

debian/receptor-python-worker.1:
	cd receptor-python-worker && help2man --output=../$@ --name="Receptor worker helper" --version-string="$(DEB_VERSION_UPSTREAM)" python3 -m receptor-python-worker

execute_before_dh_clean:
	rm -f golang-github-prep-socketpair/golang-github-prep-socketpair
	rm -f golang-github-jupp0r-go-priority-queue/golang-github-jupp0r-go-priority-queue

execute_after_dh_clean:
	dh_clean debian/receptorctl.1 debian/receptor-python-worker.1 debian/receptor.1

execute_before_dh_installman: debian/receptor.1

execute_before_dh_installman: debian/receptorctl.1 debian/receptor-python-worker.1

execute_before_dh_auto_clean:
	rm -f receptorctl/tests/receptorctl receptorctl/tests/receptorctl.egg-info
	rm -rf docs/guides tests/artifacts-output
	echo $(DEB_VERSION_UPSTREAM) > $(CURDIR)/receptorctl/.VERSION
	dh_auto_clean --buildsystem=pybuild --sourcedirectory=receptorctl -- --name=receptorctl
	rm $(CURDIR)/receptorctl/.VERSION
	echo $(DEB_VERSION_UPSTREAM) > $(CURDIR)/receptor-python-worker/.VERSION
	dh_auto_clean --buildsystem=pybuild --sourcedirectory=receptor-python-worker -- --name=receptor-python-worker
	rm $(CURDIR)/receptor-python-worker/.VERSION

execute_before_dh_auto_configure:
	echo $(DEB_VERSION_UPSTREAM) > $(CURDIR)/receptorctl/.VERSION
	dh_auto_configure --buildsystem=pybuild --sourcedirectory=receptorctl -- --name=receptorctl
	echo $(DEB_VERSION_UPSTREAM) > $(CURDIR)/receptor-python-worker/.VERSION
	dh_auto_configure --buildsystem=pybuild --sourcedirectory=receptor-python-worker -- --name=receptor-python-worker

execute_before_dh_auto_build:
	mkdir -p _build/src/github.com/prep
	ln -srf golang-github-prep-socketpair _build/src/github.com/prep/socketpair
	mkdir -p _build/src/github.com/jupp0r
	ln -srf golang-github-jupp0r-go-priority-queue _build/src/github.com/jupp0r/go-priority-queue
	cd docs && sphinx-build -Dhtml_theme=default -Dpygments_style=default -Dextensions=sphinx.ext.autosectionlabel source guides
	dh_auto_build --buildsystem=pybuild --sourcedirectory=receptorctl -- --name=receptorctl
	dh_auto_build --buildsystem=pybuild --sourcedirectory=receptor-python-worker -- --name=receptor-python-worker

override_dh_auto_build:
	dh_auto_build -- -ldflags "-X github.com/ansible/receptor/internal/version.Version=$(DEB_VERSION_UPSTREAM)"

execute_after_dh_auto_build:
	mv _build/bin/receptor-cl _build/bin/receptor

execute_before_dh_auto_install:
	dh_auto_install --buildsystem=pybuild --sourcedirectory=receptorctl -- --name=receptorctl
	dh_auto_install --buildsystem=pybuild --sourcedirectory=receptor-python-worker -- --name=receptor-python-worker

execute_after_dh_auto_test:
	cd receptorctl/tests && ln -sf ../receptorctl . && ln -sf ../receptorctl.egg-info .
	mkdir -p tests/artifacts-output
	ln -sfr _build/bin/receptor tests/artifacts-output/receptor
	dh_auto_test --buildsystem=pybuild --sourcedirectory=receptorctl -- --name=receptorctl --test-tox

## receptor 1.4.8

=== Makefile ===
--- 
+++ 
@@ -1,10 +1,13 @@
-# If the current commit has been tagged, use that as the version.
-# Otherwise include short commit hash.
+# If the current git commit has been tagged, use <tag> as the version. (e.g. v1.4.5)
+# Otherwise the version is <tag>+git<short commit hash> (e.g. 1.4.5+f031d2)
 OFFICIAL_VERSION := $(shell if VER=`git describe --exact-match --tags 2>/dev/null`; then echo $$VER; else echo ""; fi)
-ifeq ($(OFFICIAL_VERSION),)
-VERSION := $(shell git describe --tags | cut -d - -f -1)+g$(shell git rev-parse --short HEAD)
-else
-VERSION := $(OFFICIAL_VERSION)
+ifneq ($(OFFICIAL_VERSION),)
+	VERSION := $(OFFICIAL_VERSION)
+else ifneq ($(shell git tag --list),)
+	VERSION := $(shell git describe --tags | cut -d - -f -1)+$(shell git rev-parse --short HEAD)
+else ifeq ($(VERSION),)
+	VERSION := $(error No tags found in git repository)
+# else VERSION was passed as a command-line argument to make
 endif
 
 
@@ -46,8 +49,15 @@
 	DEBUGFLAGS=
 endif
 
+GO ?= go
+
 receptor: $(shell find pkg -type f -name '*.go') ./cmd/receptor-cl/receptor.go
-	CGO_ENABLED=0 GOFLAGS="-buildvcs=false" go build -o receptor $(DEBUGFLAGS) -ldflags "-X 'github.com/ansible/receptor/internal/version.Version=$(VERSION)'" $(TAGPARAM) ./cmd/receptor-cl
+	CGO_ENABLED=0 GOFLAGS="-buildvcs=false" $(GO) build \
+		-o receptor \
+		$(DEBUGFLAGS) \
+		-ldflags "-X 'github.com/ansible/receptor/internal/version.Version=$(VERSION)'" \
+		$(TAGPARAM) \
+		./cmd/receptor-cl
 
 clean:
 	@rm -fv .container-flag*
@@ -87,10 +97,10 @@
 	@golint cmd/... pkg/... example/...
 
 receptorctl-lint: receptorctl/.VERSION
-	@cd receptorctl && tox -e lint
+	@cd receptorctl && nox -s lint
 
 format:
-	@find cmd/ pkg/ -type f -name '*.go' -exec go fmt {} \;
+	@find cmd/ pkg/ -type f -name '*.go' -exec $(GO) fmt {} \;
 
 fmt: format
 
@@ -99,19 +109,40 @@
 
 build-all:
 	@echo "Running Go builds..." && \
-	GOOS=windows go build -o receptor.exe ./cmd/receptor-cl && \
-	GOOS=darwin go build -o receptor.app ./cmd/receptor-cl && \
-	go build example/*.go && \
-	go build -o receptor --tags no_backends,no_services,no_tls_config ./cmd/receptor-cl && \
-	go build -o receptor ./cmd/receptor-cl
-
+	GOOS=windows $(GO) build \
+		-o receptor.exe \
+		./cmd/receptor-cl && \
+	GOOS=darwin $(GO) build \
+		-o receptor.app \
+		./cmd/receptor-cl && \
+	$(GO) build \
+		example/*.go && \
+	$(GO) build \
+		-o receptor \
+		--tags no_backends,no_services,no_tls_config \
+		./cmd/receptor-cl && \
+	$(GO) build \
+		-o receptor \
+		-ldflags "-X 'github.com/ansible/receptor/internal/version.Version=$(VERSION)'" \
+		./cmd/receptor-cl
+
+BINNAME='receptor'
+CHECKSUM_PROGRAM='sha256sum'
+GOARCH=$(ARCH)
+GOOS=$(OS)
 DIST := receptor_$(shell echo '$(VERSION)' | sed 's/^v//')_$(GOOS)_$(GOARCH)
 build-package:
 	@echo "Building and packaging binary for $(GOOS)/$(GOARCH) as dist/$(DIST).tar.gz" && \
 	mkdir -p dist/$(DIST) && \
-	GOOS=$(GOOS) GOARCH=$(GOARCH) CGO_ENABLED=0 go build -o dist/$(DIST)/$(BINNAME) $(DEBUGFLAGS) -ldflags "-X 'github.com/ansible/receptor/internal/version.Version=$(VERSION)'" $(TAGPARAM) ./cmd/receptor-cl && \
+	GOOS=$(GOOS) GOARCH=$(GOARCH) CGO_ENABLED=0 $(GO) build \
+		-o dist/$(DIST)/$(BINNAME) \
+		$(DEBUGFLAGS) \
+		-ldflags "-X 'github.com/ansible/receptor/internal/version.Version=$(VERSION)'" \
+		$(TAGPARAM) \
+		./cmd/receptor-cl && \
 	tar -C dist/$(DIST) -zcf dist/$(DIST).tar.gz $(BINNAME) && \
-	cd dist/ && sha256sum $(DIST).tar.gz >> checksums.txt
+	cd dist/ && \
+	$(CHECKSUM_PROGRAM) $(DIST).tar.gz >> checksums.txt
 
 RUNTEST ?=
 ifeq ($(RUNTEST),)
@@ -124,7 +155,7 @@
 COVERAGE_FILE='coverage.txt'
 
 coverage: build-all
-	PATH="${PWD}:${PATH}" go test $$(go list ./... | grep -vE $(BLOCKLIST)) \
+	PATH="${PWD}:${PATH}" $(GO) test $$($(GO) list ./... | grep -vE $(BLOCKLIST)) \
 	  $(TESTCMD) \
 	  -count=1 \
 	  -cover \
@@ -135,10 +166,10 @@
 
 test: receptor
 	PATH="${PWD}:${PATH}" \
-	go test ./... $(TESTCMD) -count=1 -race -timeout 5m
+	$(GO) test ./... $(TESTCMD) -count=1 -race -timeout 5m
 
 receptorctl-test: receptorctl/.VERSION
-	@cd receptorctl && tox -e py3
+	@cd receptorctl && nox -s tests
 
 testloop: receptor
 	@i=1; while echo "------ $$i" && \

=== debian/changelog ===
receptor (1.4.8-1) unstable; urgency=medium

  * New upstream version 1.4.8
  * Extend use_old_gomock
  * Drop tox
  * Install missing files using before-test

 -- Jérémy Lal <kapouer@melix.org>  Tue, 30 Jul 2024 14:43:49 +0200

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,6 @@
  python3-click,
  python3-dateutil,
  python3-yaml,
- tox,
  ca-certificates,
  help2man,
  lsof,

=== debian/rules ===
--- 
+++ 
@@ -79,5 +79,5 @@
 	cd receptorctl/tests && ln -sf ../receptorctl . && ln -sf ../receptorctl.egg-info .
 	mkdir -p tests/artifacts-output
 	ln -sfr _build/bin/receptor tests/artifacts-output/receptor
-	dh_auto_test --buildsystem=pybuild --sourcedirectory=receptorctl -- --name=receptorctl --test-tox
+	dh_auto_test --buildsystem=pybuild --sourcedirectory=receptorctl -- --name=receptorctl --before-test="cp -r {dir}/tests/mesh-definitions {build_dir}/tests/"

## receptor 1.5.1

=== debian/changelog ===
receptor (1.5.1-1) unstable; urgency=medium

  * New upstream version 1.5.1

 -- Jérémy Lal <kapouer@melix.org>  Tue, 03 Dec 2024 17:30:47 +0100

receptor (1.5.0-1) unstable; urgency=medium

  * New upstream version 1.5.0

 -- Jérémy Lal <kapouer@melix.org>  Mon, 25 Nov 2024 14:17:54 +0100

receptor (1.4.11-1) unstable; urgency=medium

  * New upstream version 1.4.11
  * Add dependencies
  * uber-mock is available, drop compat patch
  * Exclude tests/goroutines/simple_config.go from build

 -- Jérémy Lal <kapouer@melix.org>  Wed, 20 Nov 2024 16:36:58 +0100

## receptor 1.5.2

=== debian/changelog ===
receptor (1.5.2-1) unstable; urgency=medium

  * New upstream version 1.5.2. Closes: #1091569.

 -- Jérémy Lal <kapouer@melix.org>  Sun, 12 Jan 2025 21:22:14 +0100

=== debian/control ===
--- 
+++ 
@@ -28,7 +28,7 @@
  golang-github-fsnotify-fsnotify-dev,
  golang-github-ghjm-cmdline-dev,
  golang-github-golang-jwt-jwt-dev,
- golang-github-golang-mock-dev,
+ golang-github-google-go-cmp-dev,
  golang-github-google-shlex-dev,
  golang-github-gorilla-websocket-dev,
  golang-github-minio-highwayhash-dev,
@@ -36,9 +36,14 @@
  golang-github-quic-go-quic-go-dev,
  golang-github-rogpeppe-go-internal-dev,
  golang-github-songgao-water-dev,
+ golang-github-spf13-cobra-dev,
+ golang-github-spf13-viper-dev,
  golang-github-vishvananda-netlink-dev,
  golang-golang-x-net-dev,
+ golang-golang-x-sys-dev,
  golang-gopkg-yaml.v2-dev,
+ golang-go.uber-mock-dev,
+ golang-uber-goleak-dev,
  golang-k8s-api-dev,
  golang-k8s-apimachinery-dev,
  golang-k8s-client-go-dev,
@@ -58,7 +63,7 @@
  golang-github-fsnotify-fsnotify-dev,
  golang-github-ghjm-cmdline-dev,
  golang-github-golang-jwt-jwt-dev,
- golang-github-golang-mock-dev,
+ golang-github-google-go-cmp-dev,
  golang-github-google-shlex-dev,
  golang-github-gorilla-websocket-dev,
  golang-github-minio-highwayhash-dev,
@@ -66,9 +71,14 @@
  golang-github-quic-go-quic-go-dev,
  golang-github-rogpeppe-go-internal-dev,
  golang-github-songgao-water-dev,
+ golang-github-spf13-cobra-dev,
+ golang-github-spf13-viper-dev,
  golang-github-vishvananda-netlink-dev,
  golang-golang-x-net-dev,
+ golang-golang-x-sys-dev,
  golang-gopkg-yaml.v2-dev,
+ golang-go.uber-mock-dev,
+ golang-uber-goleak-dev,
  golang-k8s-api-dev,
  golang-k8s-apimachinery-dev,
  golang-k8s-client-go-dev,
@@ -85,8 +95,8 @@
 Architecture: any
 Depends: ${misc:Depends},
  ${shlibs:Depends},
-	python3-receptorctl,
-	python3-receptor-python-worker,
+ python3-receptorctl,
+ python3-receptor-python-worker,
 Built-Using: ${misc:Built-Using}
 Suggests: receptor-doc
 Description: Daemon for controlling a mesh of nodes and workers

## receptor 1.5.3

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 ifneq ($(OFFICIAL_VERSION),)
 	VERSION := $(OFFICIAL_VERSION)
 else ifneq ($(shell git tag --list),)
-	VERSION := $(shell git describe --tags | cut -d - -f -1)+$(shell git rev-parse --short HEAD)
+	VERSION := $(shell git describe --tags | cut -d - -f -1)+git$(shell git rev-parse --short HEAD)
 else ifeq ($(VERSION),)
 	VERSION := $(error No tags found in git repository)
 # else VERSION was passed as a command-line argument to make
@@ -96,7 +96,7 @@
 lint:
 	@golint cmd/... pkg/... example/...
 
-receptorctl-lint: receptorctl/.VERSION
+receptorctl-lint: receptor receptorctl/.VERSION
 	@cd receptorctl && nox -s lint
 
 format:
@@ -117,10 +117,6 @@
 		./cmd/receptor-cl && \
 	$(GO) build \
 		example/*.go && \
-	$(GO) build \
-		-o receptor \
-		--tags no_backends,no_services,no_tls_config \
-		./cmd/receptor-cl && \
 	$(GO) build \
 		-o receptor \
 		-ldflags "-X 'github.com/ansible/receptor/internal/version.Version=$(VERSION)'" \
@@ -155,20 +151,25 @@
 COVERAGE_FILE='coverage.txt'
 
 coverage: build-all
-	PATH="${PWD}:${PATH}" $(GO) test $$($(GO) list ./... | grep -vE $(BLOCKLIST)) \
-	  $(TESTCMD) \
-	  -count=1 \
-	  -cover \
-	  -covermode=atomic \
-	  -coverprofile=$(COVERAGE_FILE) \
-	  -race \
-	  -timeout 5m
+	PATH="${PWD}:${PATH}" \
+		$(GO) test $$($(GO) list ./... | grep -vE $(BLOCKLIST)) \
+		$(TESTCMD) \
+		-count=1 \
+		-cover \
+		-covermode=atomic \
+		-coverprofile=$(COVERAGE_FILE) \
+		-race \
+		-timeout 5m
 
 test: receptor
 	PATH="${PWD}:${PATH}" \
-	$(GO) test ./... $(TESTCMD) -count=1 -race -timeout 5m
-
-receptorctl-test: receptorctl/.VERSION
+		$(GO) test $$($(GO) list ./...) \
+		$(TESTCMD) \
+		-count=1 \
+		-race \
+		-timeout 5m
+
+receptorctl-test: receptorctl/.VERSION receptor
 	@cd receptorctl && nox -s tests
 
 testloop: receptor

=== debian/changelog ===
receptor (1.5.3-1) unstable; urgency=medium

  * New upstream version 1.5.3
  * patch: revert pyroscope for now
  * patch: drop a failing test caused by go 1.24 rsa change.
    Closes: #1096226.

 -- Jérémy Lal <kapouer@melix.org>  Wed, 19 Feb 2025 19:59:28 +0100

=== debian/rules ===
--- 
+++ 
@@ -6,8 +6,9 @@
 # needed by tests
 export DH_GOLANG_INSTALL_EXTRA := pkg/controlsvc/reload_test_yml
 
-# do not package example
-export DH_GOLANG_EXCLUDES := example
+export DH_GOLANG_EXCLUDES := \
+ example \
+ github.com/ansible/receptor/tests/goroutines
 
 # do not test kubernetes yet
 export SKIP_KUBE = 1
@@ -66,7 +67,7 @@
 	dh_auto_build --buildsystem=pybuild --sourcedirectory=receptor-python-worker -- --name=receptor-python-worker
 
 override_dh_auto_build:
-	dh_auto_build -- -ldflags "-X github.com/ansible/receptor/internal/version.Version=$(DEB_VERSION_UPSTREAM)"
+	dh_auto_build -- -ldflags "-X 'github.com/ansible/receptor/internal/version.Version=$(DEB_VERSION_UPSTREAM)'"
 
 execute_after_dh_auto_build:
 	mv _build/bin/receptor-cl _build/bin/receptor
@@ -75,6 +76,9 @@
 	dh_auto_install --buildsystem=pybuild --sourcedirectory=receptorctl -- --name=receptorctl
 	dh_auto_install --buildsystem=pybuild --sourcedirectory=receptor-python-worker -- --name=receptor-python-worker
 
+override_dh_auto_test:
+	dh_auto_test --builddirectory=_build --buildsystem=golang -- -p 1 
+
 execute_after_dh_auto_test:
 	cd receptorctl/tests && ln -sf ../receptorctl . && ln -sf ../receptorctl.egg-info .
 	mkdir -p tests/artifacts-output

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
 https://github.com/ansible/receptor/tags \
 .*?@ANY_VERSION@@ARCHIVE_EXT@ group

opts="mode=git,pgpmode=none,component=golang-github-jupp0r-go-priority-queue,filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%golang-github-jupp0r-go-priority-queue-$1$2%" \
 https://github.com/jupp0r/go-priority-queue \
 HEAD ignore

opts="mode=git,pgpmode=none,component=golang-github-prep-socketpair,filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%golang-github-prep-socketpair-$1$2%" \
 https://github.com/prep/socketpair \
 HEAD ignore

## receptor 1.5.5

=== Makefile ===
--- 
+++ 
@@ -72,7 +72,7 @@
 	@rm -fv receptor-python-worker/dist/*
 	@rm -rfv receptorctl-test-venv/
 
-ARCH=amd64
+ARCH ?= amd64
 OS=linux
 
 KUBECTL_BINARY=./kubectl

=== docs/Makefile ===
--- 
+++ 
@@ -11,11 +11,24 @@
 # Put it first so that "make" without argument is like "make help".
 help:
 	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)
+	@echo -e "  doc8        doc8 linter"
+	@echo -e "  lint        All documentation linters (including linkcheck)"
+	@echo -e "  rstcheck    rstcheck linter"
 
-.PHONY: help Makefile
+.PHONY: doc8 help lint Makefile rstcheck server
+
+doc8:
+	doc8 --ignore D001 .
+
+# Documentation linters
+lint: doc8 linkcheck rstcheck
+
+rstcheck:
+	-rstcheck --recursive --warn-unknown-settings .
 
 # Catch-all target: route all unknown targets to Sphinx using the new
 # "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
+# Includes linkcheck
 %: Makefile
 	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== docs/requirements.txt ===
doc8
pbr
rstcheck >= 6
six
sphinx
sphinx_ansible_theme

=== docs/source/requirements.txt ===
pbr
sphinx
sphinx-ansible-theme
six

=== debian/changelog ===
receptor (1.5.5-2) unstable; urgency=medium

  * Pass --no-parallel for tests. Closes: #1109561

 -- Jérémy Lal <kapouer@melix.org>  Mon, 21 Jul 2025 13:08:42 +0200

receptor (1.5.5-1) unstable; urgency=medium

  * New upstream version 1.5.5
    This release addresses some security concerns by restoring
    native TLS certificate validation behavior.

 -- Jérémy Lal <kapouer@melix.org>  Tue, 13 May 2025 09:10:09 +0200

receptor (1.5.4-1) unstable; urgency=medium

  * New upstream version 1.5.4
  * Patching go.mod is useless
  * No longer remove stretchr-testify from go.mod

 -- Jérémy Lal <kapouer@melix.org>  Tue, 08 Apr 2025 13:17:02 +0200

=== debian/control ===
--- 
+++ 
@@ -38,6 +38,7 @@
  golang-github-songgao-water-dev,
  golang-github-spf13-cobra-dev,
  golang-github-spf13-viper-dev,
+ golang-github-stretchr-testify-dev,
  golang-github-vishvananda-netlink-dev,
  golang-golang-x-net-dev,
  golang-golang-x-sys-dev,
@@ -73,6 +74,7 @@
  golang-github-songgao-water-dev,
  golang-github-spf13-cobra-dev,
  golang-github-spf13-viper-dev,
+ golang-github-stretchr-testify-dev,
  golang-github-vishvananda-netlink-dev,
  golang-golang-x-net-dev,
  golang-golang-x-sys-dev,

=== debian/rules ===
--- 
+++ 
@@ -77,7 +77,7 @@
 	dh_auto_install --buildsystem=pybuild --sourcedirectory=receptor-python-worker -- --name=receptor-python-worker
 
 override_dh_auto_test:
-	dh_auto_test --builddirectory=_build --buildsystem=golang -- -p 1 
+	dh_auto_test --builddirectory=_build --buildsystem=golang --no-parallel
 
 execute_after_dh_auto_test:
 	cd receptorctl/tests && ln -sf ../receptorctl . && ln -sf ../receptorctl.egg-info .
